import java.awt.* ;
import java.io.* ;
import java.awt.event.* ;

class FenetreCommunication extends Frame {
	protected String [] chaine = new String[15] ; 
	protected int nblignes, k ;
	protected TextArea texte ;
	protected Button b ;
	protected Delegue delegue ;
	protected Adaptateur adapt ;

        FenetreCommunication () {
		delegue = new Delegue(this);
		setLayout(new BorderLayout()) ;
		texte = new TextArea();
		add("North", texte) ;
		adapt = new Adaptateur(delegue);
		b = new Button("Suite"); 
                add("South", b) ;
                b.addActionListener(adapt);
                this.addWindowListener(adapt);
		chargement() ;
		k = 0 ;
		}

	public void chargement(){
		BufferedReader fichier ;
		try 	{
			fichier =new BufferedReader(new FileReader("texte.txt")) ;
			}
		catch (IOException e) {
			texte.setText("erreur de fichier") ; return ; 
			}
		try 	{ 
			nblignes = Integer.parseInt(fichier.readLine()) ;
			for (int i = 0 ; i < nblignes ; i++)
				chaine[i] = fichier.readLine() ;
			}
		catch (IOException e) {
			texte.setText("erreur de transfert") ; return ; 
			}
		}
	}

public class Communication {
	public static void main(String[] args) {
		FenetreCommunication f = new FenetreCommunication();
                f.pack();
                f.setLocationRelativeTo(null); //the window is placed in the center of the screen.
		f.setVisible(true); 
		}
	}

class Delegue {
	protected FenetreCommunication com ;

	Delegue(FenetreCommunication c) {
		com = c ;
		}

	public void traiter() {
		if (com.k < com.nblignes) {
		    //completer :
		    }
		}

       public void exit() {
		System.exit(0);
		}
	}

class Adaptateur implements ActionListener, WindowListener  {
	protected Delegue delegue ;

	public Adaptateur(Delegue d) {
		delegue = d ;
		}

	public void actionPerformed(ActionEvent e) {
		delegue.traiter() ;
		} 
 
        public void windowOpened (WindowEvent e) {}
	public void windowClosing (WindowEvent e) { // ferme la fenetre
		delegue.exit();
		}
	public void windowClosed (WindowEvent e) {}
	public void windowIconified (WindowEvent e) {}
	public void windowDeiconified (WindowEvent e) {}
	public void windowActivated (WindowEvent e) {}
	public void windowDeactivated (WindowEvent e) {}
	}
