import java.awt.* ;			
import ...			

// la classe qui s'occupe de l'interface (la VUE)

class Fenetre extends Frame {
	protected Panel p1, p2, p3, p31, p32 ;
	protected TextArea txt ;						
	protected Button bouton1, bouton2, bouton3 ;
	protected CheckboxGroup cbg ;
	protected Checkbox chb1, chb2, chb3 ;
	protected List selection1, selection2 ;		
	protected Delegue ... ;
	protected Adaptateur ... ;	
	
	Fenetre() {
		setLayout(new FlowLayout()) ;
		p1 = new Panel() ;
		p1.setLayout(new GridLayout(4,1)) ;
		p1.add(new Label("Jour")) ;			
		selection1 = new List(3) ;
		selection1.addItem("lundi") ;
		selection1.addItem("mardi") ;
		selection1.addItem("mercredi") ;
		selection1.addItem("jeudi") ;
		selection1.addItem("vendredi") ;
		selection1.addItem("samedi") ;
		selection1.addItem("dimanche") ;
		p1.add(selection1) ;
		p1.add(new Label("Horaire")) ;			
		selection2 = new List(3) ;
		selection2.addItem("9 h - 12 h") ;
		selection2.addItem("12 h - 15 h") ;
		selection2.addItem("15 h - 18 h") ;
		selection2.addItem("18 h - 21 h") ;
		p1.add(selection2) ;
		add(p1) ;

		p2 = new Panel() ;
		p2.setLayout(new GridLayout(4,1)) ;
		p2.add(new Label("Localisation")) ;	
		cbg = new CheckboxGroup(); 
		chb1 = new Checkbox("Paris", cbg, true); 
		p2.add(chb1) ;
		chb2 = new Checkbox("Lyon", cbg, false); 
		p2.add(chb2) ;
		chb3 = new Checkbox("Marseille", cbg, false); 
		p2.add(chb3) ;
		add(p2) ;

		p3 = new Panel() ;
		p3.setLayout(new BorderLayout()) ;

		p31 = new Panel();
		bouton1 = new Button("Valider") ; p31.add(bouton1) ;	
		bouton2 = new Button("Dslectionner") ; p31.add(bouton2) ;
		p3.add("North", p31) ;	
		txt = new TextArea(5,30) ; 
		p3.add("Center",txt) ;
		Panel p32 = new Panel() ;
		bouton3 = new Button("Quitter") ; 
		p32.add(bouton3) ;
		p3.add("South", p32) ;
		add(p3) ;

		delegue = ...
		adapt = ...	
		addWindowListener ...
		bouton1.addActionListener ...
		bouton2.addActionListener ...
		bouton3.addActionListener ...	
	}
}

// la classe utilisateur

public class UtilFenetre {
					
	public static void main(String args[]) {
		Fenetre f = new Fenetre() ;
		f.pack() ; f.show() ;  
		}
}

// la classe Delegue qui s'occupe de la partie traitement (la METHODE)

class Delegue {						
	protected Fenetre fen ;

	Delegue(Fenetre f) {				
		fen = f ; 
		}

	public void quitter() {
		... 
		}
	
	public void annulle() {
		fen.selection1.deselect(...) ;
		fen.selection2.deselect(...) ;
		fen.chb1.setState(...) ;
		fen.chb2.setState(...) ;	
		fen.chb3.setState(...) ;	
		fen.txt.setText ... ;
		}

	public void affichetexte() {		
		String res = "Vous avez choisi le "+ ...
		res=res + "\ndans la tranche horaire " + ...
		res=res + "\n " + ...	
		fen.txt.setText ... ; 
		}
	}

// la classe Adaptateur qui s'occupe de l'aiguillage des vnements (le CONTROLEUR)

class Adaptateur implements ActionListener, WindowListener {   
	protected Delegue delegue ;			
	Adaptateur(Delegue d) {
		delegue = d ;  
		}

	// vnements surveills en tant que ActionListener
	public void actionPerformed(ActionEvent e) {	
		Object src = ...
		String param = ...
		if (param == "Quitter") delegue.quitter() ; 	
			else if (param == "Dslectionner") 
				delegue.annulle() ;
				else delegue.affichetexte() ;		
		}

	// vnements surveills en tant que WindowListener
	public void windowClosing(WindowEvent e) {
		delegue.quitter() ; 
		}				
	public void windowClosed(WindowEvent e) {}
	public void windowIconified(WindowEvent e) {}		
	public void windowDeiconified(WindowEvent e) {}
	public void windowActivated(WindowEvent e) {}
	public void windowDeactivated(WindowEvent e) {}
	public void windowOpened(WindowEvent e) {}
	}

