import java.awt.* ;
import java.awt.image.* ;
import java.awt.event.* ;
import java.io.* ;
import javax.imageio.* ;

class LoadImage extends Component {
    BufferedImage img;

    public LoadImage(int n) {
       try {
           img = ImageIO.read(new File("im"+n+".jpg"));
            } 
       catch (IOException e) {}
    }
   
    public Dimension getPreferredSize() {
       if (img == null) {
           return new Dimension(100,100);
	   } 
       else {
            return new Dimension(img.getWidth(), img.getHeight());
            }
    }
}

class FenetreChargeImages extends Frame {
	protected Panel p ;
	protected Image image ;
	protected Button suivant, precedent ;
	protected int rang ;
        protected LoadImage ldIm;
    //...

        FenetreChargeImages () {
		setLayout(new BorderLayout()) ;
                setBackground(Color.white);
		rang = 1 ;
                ldIm = new LoadImage(rang);
	        add("Center", ldIm); 
		p = new Panel() ;
		suivant = new Button("Next") ;
		p.add(suivant) ;
		precedent = new Button("Previous") ;
		p.add(precedent) ;
		add("South", p) ;
		//...
		}

        public void paint(Graphics g){
           ldIm = new LoadImage(rang);
           g.drawImage(ldIm.img, 0, 0, null);
           }
	}


public class ChargeImages {
	public static void main(String[] args) {
		FenetreChargeImages f = new FenetreChargeImages();
                f.pack();
                f.setLocationRelativeTo(null); //the window is placed in the center of the screen.
		f.setVisible(true); 
		}
	}

class Delegue {
	protected FenetreChargeImages ci ;

	Delegue(FenetreChargeImages c) {
		ci = c ;
		}

	public void avancer() {
	    //...
		ci.repaint();
		}

	public void reculer() {
	    //...
		ci.repaint() ; 
		}

	public void exit() {
		System.exit(0);
		}
	}

class Adaptateur implements ActionListener, WindowListener {
	protected Delegue delegue ;

	public Adaptateur(Delegue d) {
		delegue = d ;
		}

	public void actionPerformed(ActionEvent e) {
     	 	Object src = e.getSource();
		String param = ((Button)src).getLabel();
		//...
		}	
        public void windowOpened (WindowEvent e) {}
	public void windowClosing (WindowEvent e) { // ferme la fenetre
		delegue.exit();
		}
	public void windowClosed (WindowEvent e) {}
	public void windowIconified (WindowEvent e) {}
	public void windowDeiconified (WindowEvent e) {}
	public void windowActivated (WindowEvent e) {}
	public void windowDeactivated (WindowEvent e) {}
	}
